<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>DataTreeV1.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.upgrade</a> &gt; <span class="el_source">DataTreeV1.java</span></div><h1>DataTreeV1.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server.upgrade;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.concurrent.ConcurrentHashMap;

import org.apache.jute.InputArchive;
import org.apache.jute.OutputArchive;
import org.apache.jute.Record;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.apache.zookeeper.KeeperException;
import org.apache.zookeeper.Watcher;
import org.apache.zookeeper.KeeperException.Code;
import org.apache.zookeeper.KeeperException.NoNodeException;
import org.apache.zookeeper.Watcher.Event;
import org.apache.zookeeper.Watcher.Event.EventType;
import org.apache.zookeeper.ZooDefs.OpCode;
import org.apache.zookeeper.data.ACL;
import org.apache.zookeeper.data.Stat;
import org.apache.zookeeper.data.StatPersistedV1;
import org.apache.zookeeper.server.WatchManager;
import org.apache.zookeeper.txn.CreateTxn;
import org.apache.zookeeper.txn.DeleteTxn;
import org.apache.zookeeper.txn.ErrorTxn;
import org.apache.zookeeper.txn.SetACLTxn;
import org.apache.zookeeper.txn.SetDataTxn;
import org.apache.zookeeper.txn.TxnHeader;

/**
 * This class maintains the tree data structure. It doesn't have any networking
 * or client connection code in it so that it can be tested in a stand alone
 * way.
 * &lt;p&gt;
 * The tree maintains two parallel data structures: a hashtable that maps from
 * full paths to DataNodes and a tree of DataNodes. All accesses to a path is
 * through the hashtable. The tree is traversed only when serializing to disk.
 */
public class DataTreeV1 {
<span class="fc" id="L63">    private static final Logger LOG = LoggerFactory.getLogger(DataTreeV1.class);</span>

    /**
     * This hashtable provides a fast lookup to the datanodes. The tree is the
     * source of truth and is where all the locking occurs
     */
<span class="fc" id="L69">    private ConcurrentHashMap&lt;String, DataNodeV1&gt; nodes = new ConcurrentHashMap&lt;String, DataNodeV1&gt;();</span>

<span class="fc" id="L71">    private WatchManager dataWatches = new WatchManager();</span>

<span class="fc" id="L73">    private WatchManager childWatches = new WatchManager();</span>

    /**
     * This hashtable lists the paths of the ephemeral nodes of a session.
     */
<span class="fc" id="L78">    private Map&lt;Long, HashSet&lt;String&gt;&gt; ephemerals = new ConcurrentHashMap&lt;Long, HashSet&lt;String&gt;&gt;();</span>

    /**
     * return the ephemerals for this tree
     * @return the ephemerals for this tree
     */
    public Map&lt;Long, HashSet&lt;String&gt;&gt;  getEphemeralsMap() {
<span class="nc" id="L85">        return this.ephemerals;</span>
    }
    
    public void setEphemeralsMap(Map&lt;Long, HashSet&lt;String&gt;&gt; ephemerals) {
<span class="nc" id="L89">        this.ephemerals = ephemerals;</span>
<span class="nc" id="L90">    }</span>
    
    @SuppressWarnings(&quot;unchecked&quot;)
    public HashSet&lt;String&gt; getEphemerals(long sessionId) {
<span class="nc" id="L94">        HashSet&lt;String&gt; retv = ephemerals.get(sessionId);</span>
<span class="nc bnc" id="L95" title="All 2 branches missed.">        if (retv == null) {</span>
<span class="nc" id="L96">            return new HashSet&lt;String&gt;();</span>
        }
<span class="nc" id="L98">        HashSet&lt;String&gt; cloned = null;</span>
<span class="nc" id="L99">        synchronized(retv) {</span>
<span class="nc" id="L100">            cloned =  (HashSet&lt;String&gt;) retv.clone();</span>
<span class="nc" id="L101">        }</span>
<span class="nc" id="L102">        return cloned;</span>
    }
    
    public Collection&lt;Long&gt; getSessions() {
<span class="nc" id="L106">        return ephemerals.keySet();</span>
    }

    public DataNodeV1 getNode(String path) {
<span class="fc" id="L110">        return nodes.get(path);</span>
    }

    /**
     * This is a pointer to the root of the DataTree. It is the source of truth,
     * but we usually use the nodes hashmap to find nodes in the tree.
     */
<span class="fc" id="L117">    private DataNodeV1 root = new DataNodeV1(null, new byte[0], null, new StatPersistedV1());</span>

<span class="fc" id="L119">    public DataTreeV1() {</span>
        /* Rather than fight it, let root have an alias */
<span class="fc" id="L121">        nodes.put(&quot;&quot;, root);</span>
<span class="fc" id="L122">        nodes.put(&quot;/&quot;, root);</span>
<span class="fc" id="L123">    }</span>

    static public void copyStatPersisted(StatPersistedV1 from, StatPersistedV1 to) {
<span class="nc" id="L126">        to.setAversion(from.getAversion());</span>
<span class="nc" id="L127">        to.setCtime(from.getCtime());</span>
<span class="nc" id="L128">        to.setCversion(from.getCversion());</span>
<span class="nc" id="L129">        to.setCzxid(from.getCzxid());</span>
<span class="nc" id="L130">        to.setMtime(from.getMtime());</span>
<span class="nc" id="L131">        to.setMzxid(from.getMzxid());</span>
<span class="nc" id="L132">        to.setVersion(from.getVersion());</span>
<span class="nc" id="L133">        to.setEphemeralOwner(from.getEphemeralOwner());</span>
<span class="nc" id="L134">    }</span>

    static public void copyStat(Stat from, Stat to) {
<span class="nc" id="L137">        to.setAversion(from.getAversion());</span>
<span class="nc" id="L138">        to.setCtime(from.getCtime());</span>
<span class="nc" id="L139">        to.setCversion(from.getCversion());</span>
<span class="nc" id="L140">        to.setCzxid(from.getCzxid());</span>
<span class="nc" id="L141">        to.setMtime(from.getMtime());</span>
<span class="nc" id="L142">        to.setMzxid(from.getMzxid());</span>
<span class="nc" id="L143">        to.setVersion(from.getVersion());</span>
<span class="nc" id="L144">        to.setEphemeralOwner(from.getEphemeralOwner());</span>
<span class="nc" id="L145">        to.setDataLength(from.getDataLength());</span>
<span class="nc" id="L146">        to.setNumChildren(from.getNumChildren());</span>
<span class="nc" id="L147">    }</span>


    // public void remooveInterest(String path, Watcher nw) {
    // DataNode n = nodes.get(path);
    // if (n == null) {
    // synchronized (nonExistentWatches) {
    // HashSet&lt;Watcher&gt; list = nonExistentWatches.get(path);
    // if (list != null) {
    // list.remove(nw);
    // }
    // }
    // }
    // synchronized (n) {
    // n.dataWatchers.remove(nw);
    // n.childWatchers.remove(nw);
    // }
    // }

    /**
     * @param path
     * @param data
     * @param acl
     * @param ephemeralOwner
     *                the session id that owns this node. -1 indicates this is
     *                not an ephemeral node.
     * @param zxid
     * @param time
     * @return the patch of the created node
     * @throws KeeperException
     */
    public String createNode(String path, byte data[], List&lt;ACL&gt; acl,
            long ephemeralOwner, long zxid, long time) 
            throws KeeperException.NoNodeException, KeeperException.NodeExistsException {
<span class="fc" id="L181">        int lastSlash = path.lastIndexOf('/');</span>
<span class="fc" id="L182">        String parentName = path.substring(0, lastSlash);</span>
<span class="fc" id="L183">        String childName = path.substring(lastSlash + 1);</span>
<span class="fc" id="L184">        StatPersistedV1 stat = new StatPersistedV1();</span>
<span class="fc" id="L185">        stat.setCtime(time);</span>
<span class="fc" id="L186">        stat.setMtime(time);</span>
<span class="fc" id="L187">        stat.setCzxid(zxid);</span>
<span class="fc" id="L188">        stat.setMzxid(zxid);</span>
<span class="fc" id="L189">        stat.setVersion(0);</span>
<span class="fc" id="L190">        stat.setAversion(0);</span>
<span class="fc" id="L191">        stat.setEphemeralOwner(ephemeralOwner);</span>
<span class="fc" id="L192">        DataNodeV1 parent = nodes.get(parentName);</span>
<span class="pc bpc" id="L193" title="1 of 2 branches missed.">        if (parent == null) {</span>
<span class="nc" id="L194">            throw new KeeperException.NoNodeException();</span>
        }
<span class="fc" id="L196">        synchronized (parent) {</span>
<span class="fc bfc" id="L197" title="All 2 branches covered.">            if (parent.children.contains(childName)) {</span>
<span class="fc" id="L198">                throw new KeeperException.NodeExistsException();</span>
            }
<span class="fc" id="L200">            int cver = parent.stat.getCversion();</span>
<span class="fc" id="L201">            cver++;</span>
<span class="fc" id="L202">            parent.stat.setCversion(cver);</span>
<span class="fc" id="L203">            DataNodeV1 child = new DataNodeV1(parent, data, acl, stat);</span>
<span class="fc" id="L204">            parent.children.add(childName);</span>
<span class="fc" id="L205">            nodes.put(path, child);</span>
<span class="pc bpc" id="L206" title="1 of 2 branches missed.">            if (ephemeralOwner != 0) {</span>
<span class="nc" id="L207">                HashSet&lt;String&gt; list = ephemerals.get(ephemeralOwner);</span>
<span class="nc bnc" id="L208" title="All 2 branches missed.">                if (list == null) {</span>
<span class="nc" id="L209">                    list = new HashSet&lt;String&gt;();</span>
<span class="nc" id="L210">                    ephemerals.put(ephemeralOwner, list);</span>
                }
<span class="nc" id="L212">                synchronized(list) {</span>
<span class="nc" id="L213">                    list.add(path);</span>
<span class="nc" id="L214">                }</span>
            }
<span class="fc" id="L216">        }</span>
<span class="fc" id="L217">        dataWatches.triggerWatch(path, Event.EventType.NodeCreated);</span>
<span class="pc bpc" id="L218" title="1 of 2 branches missed.">        childWatches.triggerWatch(parentName.equals(&quot;&quot;)?&quot;/&quot;:parentName, Event.EventType.NodeChildrenChanged);</span>
<span class="fc" id="L219">        return path;</span>
    }

    public void deleteNode(String path) throws KeeperException.NoNodeException {
<span class="nc" id="L223">        int lastSlash = path.lastIndexOf('/');</span>
<span class="nc" id="L224">        String parentName = path.substring(0, lastSlash);</span>
<span class="nc" id="L225">        String childName = path.substring(lastSlash + 1);</span>
<span class="nc" id="L226">        DataNodeV1 node = nodes.get(path);</span>
<span class="nc bnc" id="L227" title="All 2 branches missed.">        if (node == null) {</span>
<span class="nc" id="L228">            throw new KeeperException.NoNodeException();</span>
        }
<span class="nc" id="L230">        nodes.remove(path);</span>
<span class="nc" id="L231">        DataNodeV1 parent = nodes.get(parentName);</span>
<span class="nc bnc" id="L232" title="All 2 branches missed.">        if (parent == null) {</span>
<span class="nc" id="L233">            throw new KeeperException.NoNodeException();</span>
        }
<span class="nc" id="L235">        synchronized (parent) {</span>
<span class="nc" id="L236">            parent.children.remove(childName);</span>
<span class="nc" id="L237">            parent.stat.setCversion(parent.stat.getCversion() + 1);</span>
<span class="nc" id="L238">            long eowner = node.stat.getEphemeralOwner();</span>
<span class="nc bnc" id="L239" title="All 2 branches missed.">            if (eowner != 0) {</span>
<span class="nc" id="L240">                HashSet&lt;String&gt; nodes = ephemerals.get(eowner);</span>
<span class="nc bnc" id="L241" title="All 2 branches missed.">                if (nodes != null) {</span>
<span class="nc" id="L242">                    synchronized(nodes) {</span>
<span class="nc" id="L243">                        nodes.remove(path);</span>
<span class="nc" id="L244">                    }</span>
                }
            }
<span class="nc" id="L247">            node.parent = null;</span>
<span class="nc" id="L248">        }</span>
<span class="nc" id="L249">        Set&lt;Watcher&gt; processed =</span>
<span class="nc" id="L250">        dataWatches.triggerWatch(path, EventType.NodeDeleted);</span>
<span class="nc" id="L251">        childWatches.triggerWatch(path, EventType.NodeDeleted, processed);</span>
<span class="nc bnc" id="L252" title="All 2 branches missed.">        childWatches.triggerWatch(parentName.equals(&quot;&quot;)?&quot;/&quot;:parentName, EventType.NodeChildrenChanged);</span>
<span class="nc" id="L253">    }</span>

    public Stat setData(String path, byte data[], int version, long zxid,
            long time) throws KeeperException.NoNodeException {
<span class="nc" id="L257">        Stat s = new Stat();</span>
<span class="nc" id="L258">        DataNodeV1 n = nodes.get(path);</span>
<span class="nc bnc" id="L259" title="All 2 branches missed.">        if (n == null) {</span>
<span class="nc" id="L260">            throw new KeeperException.NoNodeException();</span>
        }
<span class="nc" id="L262">        synchronized (n) {</span>
<span class="nc" id="L263">            n.data = data;</span>
<span class="nc" id="L264">            n.stat.setMtime(time);</span>
<span class="nc" id="L265">            n.stat.setMzxid(zxid);</span>
<span class="nc" id="L266">            n.stat.setVersion(version);</span>
<span class="nc" id="L267">            n.copyStat(s);</span>
<span class="nc" id="L268">        }</span>
<span class="nc" id="L269">        dataWatches.triggerWatch(path, EventType.NodeDataChanged);</span>
<span class="nc" id="L270">        return s;</span>
    }

    public byte[] getData(String path, Stat stat, Watcher watcher) throws KeeperException.NoNodeException {
<span class="nc" id="L274">        DataNodeV1 n = nodes.get(path);</span>
<span class="nc bnc" id="L275" title="All 2 branches missed.">        if (n == null) {</span>
<span class="nc" id="L276">            throw new KeeperException.NoNodeException();</span>
        }
<span class="nc" id="L278">        synchronized (n) {</span>
<span class="nc" id="L279">            n.copyStat(stat);</span>
<span class="nc bnc" id="L280" title="All 2 branches missed.">            if (watcher != null) {</span>
<span class="nc" id="L281">                dataWatches.addWatch(path, watcher);</span>
            }
<span class="nc" id="L283">            return n.data;</span>
<span class="nc" id="L284">        }</span>
    }

    public Stat statNode(String path, Watcher watcher) throws KeeperException.NoNodeException {
<span class="nc" id="L288">        Stat stat = new Stat();</span>
<span class="nc" id="L289">        DataNodeV1 n = nodes.get(path);</span>
<span class="nc bnc" id="L290" title="All 2 branches missed.">        if (watcher != null) {</span>
<span class="nc" id="L291">            dataWatches.addWatch(path, watcher);</span>
        }
<span class="nc bnc" id="L293" title="All 2 branches missed.">        if (n == null) {</span>
<span class="nc" id="L294">            throw new KeeperException.NoNodeException();</span>
        }
<span class="nc" id="L296">        synchronized (n) {</span>
<span class="nc" id="L297">            n.copyStat(stat);</span>
<span class="nc" id="L298">            return stat;</span>
<span class="nc" id="L299">        }</span>
    }

    public ArrayList&lt;String&gt; getChildren(String path, Stat stat, Watcher watcher) throws KeeperException.NoNodeException {
<span class="nc" id="L303">        DataNodeV1 n = nodes.get(path);</span>
<span class="nc bnc" id="L304" title="All 2 branches missed.">        if (n == null) {</span>
<span class="nc" id="L305">            throw new KeeperException.NoNodeException();</span>
        }
<span class="nc" id="L307">        synchronized (n) {</span>
<span class="nc" id="L308">            ArrayList&lt;String&gt; children = new ArrayList&lt;String&gt;();</span>
<span class="nc" id="L309">            children.addAll(n.children);</span>
<span class="nc bnc" id="L310" title="All 2 branches missed.">            if (watcher != null) {</span>
<span class="nc" id="L311">                childWatches.addWatch(path, watcher);</span>
            }
<span class="nc" id="L313">            return children;</span>
<span class="nc" id="L314">        }</span>
    }

    public Stat setACL(String path, List&lt;ACL&gt; acl, int version) throws KeeperException.NoNodeException {
<span class="nc" id="L318">        Stat stat = new Stat();</span>
<span class="nc" id="L319">        DataNodeV1 n = nodes.get(path);</span>
<span class="nc bnc" id="L320" title="All 2 branches missed.">        if (n == null) {</span>
<span class="nc" id="L321">            throw new KeeperException.NoNodeException();</span>
        }
<span class="nc" id="L323">        synchronized (n) {</span>
<span class="nc" id="L324">            n.stat.setAversion(version);</span>
<span class="nc" id="L325">            n.acl = acl;</span>
<span class="nc" id="L326">            n.copyStat(stat);</span>
<span class="nc" id="L327">            return stat;</span>
<span class="nc" id="L328">        }</span>
    }

    @SuppressWarnings(&quot;unchecked&quot;)
    public List&lt;ACL&gt; getACL(String path, Stat stat) throws KeeperException.NoNodeException {
<span class="nc" id="L333">        DataNodeV1 n = nodes.get(path);</span>
<span class="nc bnc" id="L334" title="All 2 branches missed.">        if (n == null) {</span>
<span class="nc" id="L335">            throw new KeeperException.NoNodeException();</span>
        }
<span class="nc" id="L337">        synchronized (n) {</span>
<span class="nc" id="L338">            n.copyStat(stat);</span>
<span class="nc" id="L339">            return new ArrayList&lt;ACL&gt;(n.acl);</span>
<span class="nc" id="L340">        }</span>
    }

<span class="fc" id="L343">    static public class ProcessTxnResult {</span>
        public long clientId;

        public int cxid;

        public long zxid;

        public int err;

        public int type;

        public String path;

        public Stat stat;

        /**
         * Equality is defined as the clientId and the cxid being the same. This
         * allows us to use hash tables to track completion of transactions.
         *
         * @see java.lang.Object#equals(java.lang.Object)
         */
        @Override
        public boolean equals(Object o) {
<span class="nc bnc" id="L366" title="All 2 branches missed.">            if (o instanceof ProcessTxnResult) {</span>
<span class="nc" id="L367">                ProcessTxnResult other = (ProcessTxnResult) o;</span>
<span class="nc bnc" id="L368" title="All 4 branches missed.">                return other.clientId == clientId &amp;&amp; other.cxid == cxid;</span>
            }
<span class="nc" id="L370">            return false;</span>
        }

        /**
         * See equals() to find the rational for how this hashcode is generated.
         *
         * @see ProcessTxnResult#equals(Object)
         * @see java.lang.Object#hashCode()
         */
        @Override
        public int hashCode() {
<span class="nc" id="L381">            return (int) ((clientId ^ cxid) % Integer.MAX_VALUE);</span>
        }

    }

<span class="fc" id="L386">    public volatile long lastProcessedZxid = 0;</span>

    @SuppressWarnings(&quot;unchecked&quot;)
    public ProcessTxnResult processTxn(TxnHeader header, Record txn) {
<span class="fc" id="L390">        ProcessTxnResult rc = new ProcessTxnResult();</span>

<span class="fc" id="L392">        String debug = &quot;&quot;;</span>
        try {
<span class="fc" id="L394">            rc.clientId = header.getClientId();</span>
<span class="fc" id="L395">            rc.cxid = header.getCxid();</span>
<span class="fc" id="L396">            rc.zxid = header.getZxid();</span>
<span class="fc" id="L397">            rc.type = header.getType();</span>
<span class="fc" id="L398">            rc.err = 0;</span>
<span class="pc bpc" id="L399" title="1 of 2 branches missed.">            if (rc.zxid &gt; lastProcessedZxid) {</span>
<span class="fc" id="L400">                lastProcessedZxid = rc.zxid;</span>
            }
<span class="pc bpc" id="L402" title="4 of 7 branches missed.">            switch (header.getType()) {</span>
            case OpCode.create:
<span class="fc" id="L404">                CreateTxn createTxn = (CreateTxn) txn;</span>
<span class="fc" id="L405">                debug = &quot;Create transaction for &quot; + createTxn.getPath();</span>
<span class="fc" id="L406">                createNode(createTxn.getPath(), createTxn.getData(), createTxn</span>
<span class="pc bpc" id="L407" title="1 of 2 branches missed.">                        .getAcl(), createTxn.getEphemeral() ? header</span>
<span class="pc" id="L408">                        .getClientId() : 0, header.getZxid(), header.getTime());</span>
<span class="fc" id="L409">                rc.path = createTxn.getPath();</span>
<span class="fc" id="L410">                break;</span>
            case OpCode.delete:
<span class="nc" id="L412">                DeleteTxn deleteTxn = (DeleteTxn) txn;</span>
<span class="nc" id="L413">                debug = &quot;Delete transaction for &quot; + deleteTxn.getPath();</span>
<span class="nc" id="L414">                deleteNode(deleteTxn.getPath());</span>
<span class="nc" id="L415">                break;</span>
            case OpCode.setData:
<span class="nc" id="L417">                SetDataTxn setDataTxn = (SetDataTxn) txn;</span>
<span class="nc" id="L418">                debug = &quot;Set data for  transaction for &quot; + setDataTxn.getPath();</span>
<span class="nc" id="L419">                rc.stat = setData(setDataTxn.getPath(), setDataTxn.getData(),</span>
<span class="nc" id="L420">                        setDataTxn.getVersion(), header.getZxid(), header</span>
<span class="nc" id="L421">                                .getTime());</span>
<span class="nc" id="L422">                break;</span>
            case OpCode.setACL:
<span class="nc" id="L424">                SetACLTxn setACLTxn = (SetACLTxn) txn;</span>
<span class="nc" id="L425">                debug = &quot;Set ACL for  transaction for &quot; + setACLTxn.getPath();</span>
<span class="nc" id="L426">                rc.stat = setACL(setACLTxn.getPath(), setACLTxn.getAcl(),</span>
<span class="nc" id="L427">                        setACLTxn.getVersion());</span>
<span class="nc" id="L428">                break;</span>
            case OpCode.closeSession:
<span class="fc" id="L430">                killSession(header.getClientId());</span>
<span class="fc" id="L431">                break;</span>
            case OpCode.error:
<span class="nc" id="L433">                ErrorTxn errTxn = (ErrorTxn) txn;</span>
<span class="nc" id="L434">                rc.err = errTxn.getErr();</span>
                break;
            }
<span class="fc" id="L437">        } catch (KeeperException e) {</span>
            // These are expected errors since we take a lazy snapshot
<span class="pc bpc" id="L439" title="1 of 2 branches missed.">            if (initialized</span>
<span class="pc bpc" id="L440" title="1 of 2 branches missed.">                    || (e.code() != Code.NONODE </span>
<span class="pc bpc" id="L441" title="1 of 2 branches missed.">                            &amp;&amp; e.code() != Code.NODEEXISTS)) {</span>
<span class="nc" id="L442">                LOG.warn(&quot;Failed:&quot; + debug, e);</span>
            }
<span class="fc" id="L444">        }</span>
<span class="fc" id="L445">        return rc;</span>
    }

    void killSession(long session) {
        // the list is already removed from the ephemerals
        // so we do not have to worry about synchronyzing on
        // the list. This is only called from FinalRequestProcessor
        // so there is no need for synchornization. The list is not
        // changed here. Only create and delete change the list which
        // are again called from FinalRequestProcessor in sequence.
<span class="fc" id="L455">        HashSet&lt;String&gt; list = ephemerals.remove(session);</span>
<span class="pc bpc" id="L456" title="1 of 2 branches missed.">        if (list != null) {</span>
<span class="nc bnc" id="L457" title="All 2 branches missed.">            for (String path : list) {</span>
                try {
<span class="nc" id="L459">                    deleteNode(path);</span>
<span class="nc bnc" id="L460" title="All 2 branches missed.">                    if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L461">                        LOG.debug(&quot;Deleting ephemeral node &quot; + path</span>
                                + &quot; for session 0x&quot;
<span class="nc" id="L463">                                + Long.toHexString(session));</span>
                    }
<span class="nc" id="L465">                } catch (NoNodeException e) {</span>
<span class="nc" id="L466">                    LOG.warn(&quot;Ignoring NoNodeException for path &quot; + path</span>
                            + &quot; while removing ephemeral for dead session 0x&quot;
<span class="nc" id="L468">                            + Long.toHexString(session));</span>
<span class="nc" id="L469">                }</span>
<span class="nc" id="L470">            }</span>
        }
<span class="fc" id="L472">    }</span>

    /**
     * this method uses a stringbuilder to create a new
     * path for children. This is faster than string
     * appends ( str1 + str2).
     * @param oa OutputArchive to write to.
     * @param path a string builder.
     * @throws IOException
     * @throws InterruptedException
     */
    void serializeNode(OutputArchive oa, StringBuilder path)
            throws IOException, InterruptedException {
<span class="nc" id="L485">        String pathString = path.toString();</span>
<span class="nc" id="L486">        DataNodeV1 node = getNode(pathString);</span>
<span class="nc bnc" id="L487" title="All 2 branches missed.">        if (node == null) {</span>
<span class="nc" id="L488">            return;</span>
        }
<span class="nc" id="L490">        String children[] = null;</span>
<span class="nc" id="L491">        synchronized (node) {</span>
<span class="nc" id="L492">            scount++;</span>
<span class="nc" id="L493">            oa.writeString(pathString, &quot;path&quot;);</span>
<span class="nc" id="L494">            oa.writeRecord(node, &quot;node&quot;);</span>
<span class="nc" id="L495">            children = node.children.toArray(new String[node.children.size()]);</span>
<span class="nc" id="L496">        }</span>
<span class="nc" id="L497">        path.append('/');</span>
<span class="nc" id="L498">        int off = path.length();</span>
<span class="nc bnc" id="L499" title="All 2 branches missed.">        if (children != null) {</span>
<span class="nc bnc" id="L500" title="All 2 branches missed.">            for (String child : children) {</span>
                //since this is single buffer being resused
                // we need
                // to truncate the previous bytes of string.
<span class="nc" id="L504">                path.delete(off, Integer.MAX_VALUE);</span>
<span class="nc" id="L505">                path.append(child);</span>
<span class="nc" id="L506">                serializeNode(oa, path);</span>
            }
        }
<span class="nc" id="L509">    }</span>

    int scount;

<span class="fc" id="L513">    public boolean initialized = false;</span>

    public void serialize(OutputArchive oa, String tag) throws IOException,
            InterruptedException {
<span class="nc" id="L517">        scount = 0;</span>
<span class="nc" id="L518">        serializeNode(oa, new StringBuilder(&quot;&quot;));</span>
        // / marks end of stream
        // we need to check if clear had been called in between the snapshot.
<span class="nc bnc" id="L521" title="All 2 branches missed.">        if (root != null) {</span>
<span class="nc" id="L522">            oa.writeString(&quot;/&quot;, &quot;path&quot;);</span>
        }
<span class="nc" id="L524">    }</span>

    public void deserialize(InputArchive ia, String tag) throws IOException {
<span class="fc" id="L527">        nodes.clear();</span>
<span class="fc" id="L528">        String path = ia.readString(&quot;path&quot;);</span>
<span class="fc bfc" id="L529" title="All 2 branches covered.">        while (!path.equals(&quot;/&quot;)) {</span>
<span class="fc" id="L530">            DataNodeV1 node = new DataNodeV1();</span>
<span class="fc" id="L531">            ia.readRecord(node, &quot;node&quot;);</span>
<span class="fc" id="L532">            nodes.put(path, node);</span>
<span class="fc" id="L533">            int lastSlash = path.lastIndexOf('/');</span>
<span class="fc bfc" id="L534" title="All 2 branches covered.">            if (lastSlash == -1) {</span>
<span class="fc" id="L535">                root = node;</span>
            } else {
<span class="fc" id="L537">                String parentPath = path.substring(0, lastSlash);</span>
<span class="fc" id="L538">                node.parent = nodes.get(parentPath);</span>
<span class="fc" id="L539">                node.parent.children.add(path.substring(lastSlash + 1));</span>
<span class="fc" id="L540">                long eowner = node.stat.getEphemeralOwner();</span>
<span class="pc bpc" id="L541" title="1 of 2 branches missed.">                if (eowner != 0) {</span>
<span class="nc" id="L542">                    HashSet&lt;String&gt; list = ephemerals.get(eowner);</span>
<span class="nc bnc" id="L543" title="All 2 branches missed.">                    if (list == null) {</span>
<span class="nc" id="L544">                        list = new HashSet&lt;String&gt;();</span>
<span class="nc" id="L545">                        ephemerals.put(eowner, list);</span>
                    }
<span class="nc" id="L547">                    list.add(path);</span>
                }
            }
<span class="fc" id="L550">            path = ia.readString(&quot;path&quot;);</span>
<span class="fc" id="L551">        }</span>
<span class="fc" id="L552">        nodes.put(&quot;/&quot;, root);</span>
<span class="fc" id="L553">    }</span>

    public String dumpEphemerals() {
<span class="nc" id="L556">        Set&lt;Long&gt; keys = ephemerals.keySet();</span>
<span class="nc" id="L557">        StringBuilder sb = new StringBuilder(&quot;Sessions with Ephemerals (&quot;</span>
<span class="nc" id="L558">                + keys.size() + &quot;):\n&quot;);</span>
<span class="nc bnc" id="L559" title="All 2 branches missed.">        for (long k : keys) {</span>
<span class="nc" id="L560">            sb.append(&quot;0x&quot; + Long.toHexString(k));</span>
<span class="nc" id="L561">            sb.append(&quot;:\n&quot;);</span>
<span class="nc" id="L562">            HashSet&lt;String&gt; tmp = ephemerals.get(k);</span>
<span class="nc" id="L563">            synchronized(tmp) {</span>
<span class="nc bnc" id="L564" title="All 2 branches missed.">                for (String path : tmp) {</span>
<span class="nc" id="L565">                    sb.append(&quot;\t&quot; + path + &quot;\n&quot;);</span>
<span class="nc" id="L566">                }</span>
<span class="nc" id="L567">            }</span>
<span class="nc" id="L568">        }</span>
<span class="nc" id="L569">        return sb.toString();</span>
    }

    public void removeCnxn(Watcher watcher) {
<span class="nc" id="L573">        dataWatches.removeWatcher(watcher);</span>
<span class="nc" id="L574">        childWatches.removeWatcher(watcher);</span>
<span class="nc" id="L575">    }</span>

    public void clear() {
<span class="nc" id="L578">        root = null;</span>
<span class="nc" id="L579">        nodes.clear();</span>
<span class="nc" id="L580">        ephemerals.clear();</span>
        // dataWatches = null;
        // childWatches = null;
<span class="nc" id="L583">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>